;Program compiled by Great Cow BASIC (0.98.06 2019-06-12 (Windows 32 bit))
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=12F675, r=DEC
#include <P12F675.inc>
 __CONFIG _CP_OFF & _MCLRE_ON & _WDTE_OFF & _INTRC_OSC_NOCLKOUT

;********************************************************************************

;Set aside memory locations for variables
AUXA	EQU	36
AUXB	EQU	39
AUXC	EQU	40
AUXD	EQU	41
AUXE	EQU	42
AUXJ	EQU	43
CMCOM	EQU	44
CNT	EQU	45
DELAYTEMP	EQU	32
DELAYTEMP2	EQU	33
SYSTEMP1	EQU	46
SYSWAITTEMPMS	EQU	34
SYSWAITTEMPMS_H	EQU	35
SYSWAITTEMPUS	EQU	37
SYSWAITTEMPUS_H	EQU	38

;********************************************************************************

;Vectors
	ORG	0
	pagesel	BASPROGRAMSTART
	goto	BASPROGRAMSTART
	ORG	4
	retfie

;********************************************************************************

;Start of program memory page 0
	ORG	5
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS

;Start of the main program
;*******************************************************************************
;EFEITOS SONOROS
;C/ PIC12F675
;
;AUTOR: CLAUDIO LARIOS
;DATA:14/07/2020
;USO DIDTICO
;ESTE ARQUIVO  PARTE INTEGRANTE DO BLOG LARIOS.TECNOLOGIA.WS
;*******************************************************************************/
;#define piezo     GPIO.5 'pino 2
;Dir     piezo     out
	banksel	TRISIO
	bcf	TRISIO,5
;variveis globais
;Dim cnt as byte
;Dim auxa as byte
;Dim auxb as byte
;Dim auxc as byte
;Dim auxd as byte
;Dim auxe as byte
;Dim auxj as byte
;Dim cnt as byte
;*******************************************************************************
;SUBROTINAS
;*******************************************************************************/
;*******************************************************************************
;ROTINA MAIN
;******************************************************************************/
;CMCOM = 7;//desliga comparadores
	movlw	7
	movwf	CMCOM
;GPIO = 0;//zera tudo
	banksel	GPIO
	clrf	GPIO
;TRISIO = 0b011111;//ajusta entradas e sadas
	movlw	31
	banksel	TRISIO
	movwf	TRISIO
;ANSEL = 0;// desabilita ports p/ conversores ADC
	clrf	ANSEL
;*******************************************************************************
;LOOP PRINCIPAL DE REPETIO
;*******************************************************************************/
;do
SysDoLoop_S1
;som_2passarinhos  ;//som de piado de passarinho
;delay_entre_sons  ;
;som_campainha_telefone'campainha de telefone 1
	banksel	STATUS
	call	SOM_CAMPAINHA_TELEFONE
;delay_entre_sons
	call	DELAY_ENTRE_SONS
;som_sirene1 ' arma espacial
	call	SOM_SIRENE1
;delay_entre_sons
	call	DELAY_ENTRE_SONS
;som_sirene2 'rapida
	call	SOM_SIRENE2
;delay_entre_sons
	call	DELAY_ENTRE_SONS
;som_sirene3 'alerta
	call	SOM_SIRENE3
;delay_entre_sons
	call	DELAY_ENTRE_SONS
;som_sirene4
	call	SOM_SIRENE4
;delay_entre_sons
	call	DELAY_ENTRE_SONS
;som_sirene5
	call	SOM_SIRENE5
;delay_entre_sons
	call	DELAY_ENTRE_SONS
;som_sirene6
	call	SOM_SIRENE6
;delay_entre_sons
	call	DELAY_ENTRE_SONS
;som_sirene7
	call	SOM_SIRENE7
;delay_entre_sons
	call	DELAY_ENTRE_SONS
;som_sirene8
	call	SOM_SIRENE8
;delay_entre_sons
	call	DELAY_ENTRE_SONS
;som_sirene9 'arma espacial  lenta
	call	SOM_SIRENE9
;delay_entre_sons
	call	DELAY_ENTRE_SONS
;som_sirene10 'arma espacial  rpida
	call	SOM_SIRENE10
;delay_entre_sons
	call	DELAY_ENTRE_SONS
;som_sirene11 'arma espacial  ultra rpida
	call	SOM_SIRENE11
;delay_entre_sons
	call	DELAY_ENTRE_SONS
;som_sirene12 'metralhadora espacial
	call	SOM_SIRENE12
;delay_entre_sons
	call	DELAY_ENTRE_SONS
;som_sirene13
	call	SOM_SIRENE13
;delay_entre_sons
	call	DELAY_ENTRE_SONS
;som_sirene14
	call	SOM_SIRENE14
;delay_entre_sons
	call	DELAY_ENTRE_SONS
;som_sirene15  'estranha 1
	call	SOM_SIRENE15
;delay_entre_sons
	call	DELAY_ENTRE_SONS
;som_sirene16 'estranha 2
	call	SOM_SIRENE16
;delay_entre_sons
	call	DELAY_ENTRE_SONS
;som_sirene17 'estranha 3
	call	SOM_SIRENE17
;delay_entre_sons
	call	DELAY_ENTRE_SONS
;som_sirene18 'sirene
	call	SOM_SIRENE18
;delay_entre_sons
	call	DELAY_ENTRE_SONS
;som_sirene19 ' buzina
	call	SOM_SIRENE19
;delay_entre_sons
	call	DELAY_ENTRE_SONS
;som_sirene20 'sirene bitonal  similar a francesa
	call	SOM_SIRENE20
;delay_entre_sons
	call	DELAY_ENTRE_SONS
;som_sirene21 'campainha de telefone 2
	call	SOM_SIRENE21
;delay_entre_sons
	call	DELAY_ENTRE_SONS
;som_sirene22 ' estranha 4
	call	SOM_SIRENE22
;delay_entre_sons
	call	DELAY_ENTRE_SONS
;som_sirene23 'estranha 5
	call	SOM_SIRENE23
;delay_entre_sons
	call	DELAY_ENTRE_SONS
;som_sirene24 'estranha 6
	call	SOM_SIRENE24
;delay_entre_sons
	call	DELAY_ENTRE_SONS
;loop
	goto	SysDoLoop_S1
SysDoLoop_E1
;-----------------------fim do programa -------------------------------
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

DELAY_ENTRE_SONS
;wait 1000 ms
	movlw	232
	movwf	SysWaitTempMS
	movlw	3
	movwf	SysWaitTempMS_H
	goto	Delay_MS

;********************************************************************************

Delay_MS
	incf	SysWaitTempMS_H, F
DMS_START
	movlw	142
	movwf	DELAYTEMP2
DMS_OUTER
	movlw	1
	movwf	DELAYTEMP
DMS_INNER
	decfsz	DELAYTEMP, F
	goto	DMS_INNER
	decfsz	DELAYTEMP2, F
	goto	DMS_OUTER
	decfsz	SysWaitTempMS, F
	goto	DMS_START
	decfsz	SysWaitTempMS_H, F
	goto	DMS_START
	return

;********************************************************************************

INITSYS
;Resolve OSCCAL calibration
;GCB does not load saved calibration data into OSCCAL register on Baseline PIC. Therefore the FOSC is inaccurate when using internal RC oscillator.
;Solution:  Add following as the FIRST lines in the INITSYS sub in the System.h file
;This loads the saved calibration data from the last flash memory location at POR or any time the chip is reset.
;CALL 0x3ff
	call	1023
;movwf osccal
	banksel	OSCCAL
	movwf	OSCCAL
;Set up internal oscillator
;Handle OSCCON1 register for parts that have this register
;Ensure all ports are set for digital I/O and, turn off A/D
;SET ADFM OFF
	banksel	ADCON0
	bcf	ADCON0,ADFM
;Switch off A/D Var(ADCON0)
;SET ADCON0.ADON OFF
	bcf	ADCON0,ADON
;Commence clearing any ANSEL variants in the part
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;End clearing any ANSEL variants in the part
;Turn off comparator - this is the default setting
;CMCON = 7
	movlw	7
	banksel	CMCON
	movwf	CMCON
;Turn off all ports
;GPIO = 0
	clrf	GPIO
	return

;********************************************************************************

INVERTE_SAIDA
;for auxa =1 to cnt
	clrf	AUXA
	movlw	1
	subwf	CNT,W
	btfss	STATUS, C
	goto	SysForLoopEnd82
SysForLoop82
	incf	AUXA,F
;wait 6 us
	movlw	2
	movwf	DELAYTEMP
DelayUS1
	decfsz	DELAYTEMP,F
	goto	DelayUS1
;next
	movf	CNT,W
	subwf	AUXA,W
	btfss	STATUS, C
	goto	SysForLoop82
SysForLoopEnd82
;piezo = piezo xor 1
	clrf	SysTemp1
	btfsc	GPIO,5
	incf	SysTemp1,F
	movlw	1
	xorwf	SysTemp1,F
	bcf	GPIO,5
	btfsc	SysTemp1,0
	bsf	GPIO,5
	return

;********************************************************************************

SOM_CAMPAINHA_TELEFONE
;for auxd = 1 to 3 'numero de execues
	clrf	AUXD
SysForLoop1
	incf	AUXD,F
;cnt = 100'frequencia
	movlw	100
	movwf	CNT
;for auxc = 1 to 20 'passo
	clrf	AUXC
SysForLoop2
	incf	AUXC,F
;for auxb = 1 to 50   'permanncia
	clrf	AUXB
SysForLoop3
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	50
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop3
SysForLoopEnd3
;cnt = cnt  xor 0b00001111
	movlw	15
	xorwf	CNT,F
;next
	movlw	20
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop2
SysForLoopEnd2
;wait 2000 ms
	movlw	208
	movwf	SysWaitTempMS
	movlw	7
	movwf	SysWaitTempMS_H
	call	Delay_MS
;next
	movlw	3
	subwf	AUXD,W
	btfss	STATUS, C
	goto	SysForLoop1
SysForLoopEnd1
	return

;********************************************************************************

SOM_SIRENE1
;for auxd = 1 to 10  'numero de execues
	clrf	AUXD
SysForLoop4
	incf	AUXD,F
;cnt=40;//frequencia
;for auxc = 0 to 50   'passo
	movlw	255
	movwf	AUXC
SysForLoop5
	incf	AUXC,F
;for auxb = 0 to 15   'permanncia
	movlw	255
	movwf	AUXB
SysForLoop6
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	15
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop6
SysForLoopEnd6
;if cnt > 128 then
	movf	CNT,W
	sublw	128
	btfsc	STATUS, C
	goto	ELSE5_1
;cnt = 0
	clrf	CNT
;else
	goto	ENDIF5
ELSE5_1
;cnt = cnt + 1
	incf	CNT,F
;end if
ENDIF5
;next
	movlw	50
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop5
SysForLoopEnd5
;next
	movlw	10
	subwf	AUXD,W
	btfss	STATUS, C
	goto	SysForLoop4
SysForLoopEnd4
	return

;********************************************************************************

SOM_SIRENE10
;gun space
;for auxd = 1 to 10  'numero de execues
	clrf	AUXD
SysForLoop31
	incf	AUXD,F
;cnt = 39 'frequencia
	movlw	39
	movwf	CNT
;for auxc = 1 to 18   '/passo
	clrf	AUXC
SysForLoop32
	incf	AUXC,F
;for auxb = 1 to 9   'permanncia
	clrf	AUXB
SysForLoop33
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	9
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop33
SysForLoopEnd33
;cnt = cnt - 8
	movlw	8
	subwf	CNT,F
;next
	movlw	18
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop32
SysForLoopEnd32
;next
	movlw	10
	subwf	AUXD,W
	btfss	STATUS, C
	goto	SysForLoop31
SysForLoopEnd31
	return

;********************************************************************************

SOM_SIRENE11
;space gun 5 rpida  metralhando
;for auxd = 1 to 20   'numero de execues
	clrf	AUXD
SysForLoop34
	incf	AUXD,F
;cnt = 10 'frequencia
	movlw	10
	movwf	CNT
;for auxc = 1 to 10  'passo
	clrf	AUXC
SysForLoop35
	incf	AUXC,F
;for auxb = 1 to 30   'permanncia
	clrf	AUXB
SysForLoop36
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	30
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop36
SysForLoopEnd36
;if cnt > 128 then
	movf	CNT,W
	sublw	128
	btfsc	STATUS, C
	goto	ELSE44_1
;cnt = cnt - 7
	movlw	7
	subwf	CNT,F
;else
	goto	ENDIF44
ELSE44_1
;cnt = cnt + 3
	movlw	3
	addwf	CNT,F
;end if
ENDIF44
;next
	movlw	10
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop35
SysForLoopEnd35
;next
	movlw	20
	subwf	AUXD,W
	btfss	STATUS, C
	goto	SysForLoop34
SysForLoopEnd34
	return

;********************************************************************************

SOM_SIRENE12
;space gun 4 rpida  metralhando
;for auxd = 1 to 20   'numero de execues
	clrf	AUXD
SysForLoop37
	incf	AUXD,F
;cnt = 20 'frequencia
	movlw	20
	movwf	CNT
;for auxc = 1 to 30   'passo
	clrf	AUXC
SysForLoop38
	incf	AUXC,F
;for auxb = 1 to 6  'permanncia
	clrf	AUXB
SysForLoop39
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	6
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop39
SysForLoopEnd39
;if cnt > 128 then
	movf	CNT,W
	sublw	128
	btfsc	STATUS, C
	goto	ELSE48_1
;cnt = cnt - 2
	movlw	2
	subwf	CNT,F
;else
	goto	ENDIF48
ELSE48_1
;cnt = cnt + 4
	movlw	4
	addwf	CNT,F
;end if
ENDIF48
;next
	movlw	30
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop38
SysForLoopEnd38
;next
	movlw	20
	subwf	AUXD,W
	btfss	STATUS, C
	goto	SysForLoop37
SysForLoopEnd37
	return

;********************************************************************************

SOM_SIRENE13
;gun space2
;for auxd  = 1 to 10   'numero de execues
	clrf	AUXD
SysForLoop40
	incf	AUXD,F
;cnt = 44 'frequencia
	movlw	44
	movwf	CNT
;for auxc = 1  to 18   'passo
	clrf	AUXC
SysForLoop41
	incf	AUXC,F
;for auxb = 1 to 9   'permanncia
	clrf	AUXB
SysForLoop42
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	9
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop42
SysForLoopEnd42
;cnt = cnt - 8
	movlw	8
	subwf	CNT,F
;next
	movlw	18
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop41
SysForLoopEnd41
;next
	movlw	10
	subwf	AUXD,W
	btfss	STATUS, C
	goto	SysForLoop40
SysForLoopEnd40
	return

;********************************************************************************

SOM_SIRENE14
;space gun 3  tchuuu! tchuuu!
;for auxd = 1 to 10  'numero de execues
	clrf	AUXD
SysForLoop43
	incf	AUXD,F
;cnt = 20 'frequencia
	movlw	20
	movwf	CNT
;for auxc = 1 to 30   'passo
	clrf	AUXC
SysForLoop44
	incf	AUXC,F
;for auxb = 1 to 12   'permanncia
	clrf	AUXB
SysForLoop45
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	12
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop45
SysForLoopEnd45
;if cnt > 128 then
	movf	CNT,W
	sublw	128
	btfsc	STATUS, C
	goto	ELSE55_1
;cnt = cnt - 2
	movlw	2
	subwf	CNT,F
;else
	goto	ENDIF55
ELSE55_1
;cnt = cnt + 4
	movlw	4
	addwf	CNT,F
;end if
ENDIF55
;next
	movlw	30
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop44
SysForLoopEnd44
;next
	movlw	10
	subwf	AUXD,W
	btfss	STATUS, C
	goto	SysForLoop43
SysForLoopEnd43
	return

;********************************************************************************

SOM_SIRENE15
;extranha  doleto bum doleto bum
;for auxd = 1 to 10   'numero de execues
	clrf	AUXD
SysForLoop46
	incf	AUXD,F
;cnt = 37'frequencia
	movlw	37
	movwf	CNT
;for auxc = 1  to 10   'passo
	clrf	AUXC
SysForLoop47
	incf	AUXC,F
;for auxb = 1  to 40   'permanncia
	clrf	AUXB
SysForLoop48
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	40
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop48
SysForLoopEnd48
;cnt = cnt - 20
	movlw	20
	subwf	CNT,F
;next
	movlw	10
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop47
SysForLoopEnd47
;next
	movlw	10
	subwf	AUXD,W
	btfss	STATUS, C
	goto	SysForLoop46
SysForLoopEnd46
	return

;********************************************************************************

SOM_SIRENE16
;poim poim
;for auxd = 1  to 10   'numero de execues
	clrf	AUXD
SysForLoop49
	incf	AUXD,F
;cnt = 100;//frequencia
	movlw	100
	movwf	CNT
;for auxc = 1 to 10   'passo
	clrf	AUXC
SysForLoop50
	incf	AUXC,F
;for auxb = 1 to 40   'permanncia
	clrf	AUXB
SysForLoop51
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	40
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop51
SysForLoopEnd51
;cnt = cnt - 40
	movlw	40
	subwf	CNT,F
;next
	movlw	10
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop50
SysForLoopEnd50
;next
	movlw	10
	subwf	AUXD,W
	btfss	STATUS, C
	goto	SysForLoop49
SysForLoopEnd49
	return

;********************************************************************************

SOM_SIRENE17
;bp
;for auxd = 1 to 10   'numero de execues
	clrf	AUXD
SysForLoop52
	incf	AUXD,F
;cnt = 20'frequencia
	movlw	20
	movwf	CNT
;for auxc = 1 to 10   'passo
	clrf	AUXC
SysForLoop53
	incf	AUXC,F
;for auxb = 1 to 80   'permanncia
	clrf	AUXB
SysForLoop54
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	80
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop54
SysForLoopEnd54
;cnt = cnt - 50
	movlw	50
	subwf	CNT,F
;next
	movlw	10
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop53
SysForLoopEnd53
;next
	movlw	10
	subwf	AUXD,W
	btfss	STATUS, C
	goto	SysForLoop52
SysForLoopEnd52
	return

;********************************************************************************

SOM_SIRENE18
;sirene alarme rpido 1
;for auxd = 1  to 10   'numero de execues
	clrf	AUXD
SysForLoop55
	incf	AUXD,F
;cnt = 40 'frequencia
	movlw	40
	movwf	CNT
;for auxc = 1 to 50   'passo
	clrf	AUXC
SysForLoop56
	incf	AUXC,F
;for auxb = 1 to 15  'permanncia
	clrf	AUXB
SysForLoop57
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	15
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop57
SysForLoopEnd57
;if cnt > 128 then
	movf	CNT,W
	sublw	128
	btfsc	STATUS, C
	goto	ELSE68_1
;cnt = cnt xor 0b10000000
	movlw	128
	xorwf	CNT,F
;else
	goto	ENDIF68
ELSE68_1
;cnt = cnt + 1
	incf	CNT,F
;end if
ENDIF68
;next
	movlw	50
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop56
SysForLoopEnd56
;next
	movlw	10
	subwf	AUXD,W
	btfss	STATUS, C
	goto	SysForLoop55
SysForLoopEnd55
	return

;********************************************************************************

SOM_SIRENE19
;for auxd = 1 to 10   'numero de execues
	clrf	AUXD
SysForLoop58
	incf	AUXD,F
;for auxc = 1 to 50   'passo
	clrf	AUXC
SysForLoop59
	incf	AUXC,F
;cnt = 20
	movlw	20
	movwf	CNT
;for auxb = 1 to 15   'permanncia
	clrf	AUXB
SysForLoop60
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	15
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop60
SysForLoopEnd60
;cnt = 15
	movlw	15
	movwf	CNT
;for auxb = 1 to 15   'permanncia
	clrf	AUXB
SysForLoop61
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	15
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop61
SysForLoopEnd61
;next
	movlw	50
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop59
SysForLoopEnd59
;next
	movlw	10
	subwf	AUXD,W
	btfss	STATUS, C
	goto	SysForLoop58
SysForLoopEnd58
	return

;********************************************************************************

SOM_SIRENE2
;for auxd = 1 to 100   'numero de execues
	clrf	AUXD
SysForLoop7
	incf	AUXD,F
;cnt=40;//frequencia
;for auxc = 1 to 50   'passo
	clrf	AUXC
SysForLoop8
	incf	AUXC,F
;for auxb =1 to 3  'permanncia
	clrf	AUXB
SysForLoop9
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	3
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop9
SysForLoopEnd9
;if cnt > 64 then auxj = 1
	movf	CNT,W
	sublw	64
	btfsc	STATUS, C
	goto	ENDIF9
	movlw	1
	movwf	AUXJ
ENDIF9
;if cnt = 1 then auxj = 0
	decf	CNT,W
	btfsc	STATUS, Z
	clrf	AUXJ
;if auxj = 1 then
	decf	AUXJ,W
	btfss	STATUS, Z
	goto	ELSE11_1
;cnt = cnt - 1
	decf	CNT,F
;else
	goto	ENDIF11
ELSE11_1
;cnt = cnt + 1
	incf	CNT,F
;end if
ENDIF11
;next
	movlw	50
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop8
SysForLoopEnd8
;next
	movlw	100
	subwf	AUXD,W
	btfss	STATUS, C
	goto	SysForLoop7
SysForLoopEnd7
	return

;********************************************************************************

SOM_SIRENE20
;for auxd = 1  to 10   'numero de execues
	clrf	AUXD
SysForLoop62
	incf	AUXD,F
;cnt = 200
	movlw	200
	movwf	CNT
;for auxc = 1 to 32   'passo
	clrf	AUXC
SysForLoop63
	incf	AUXC,F
;for auxb = 1 to 15   'permanncia
	clrf	AUXB
SysForLoop64
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	15
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop64
SysForLoopEnd64
;next
	movlw	32
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop63
SysForLoopEnd63
;cn t= 140
	movlw	140
	movwf	CNT
;for auxc = 1 to 48   'passo
	clrf	AUXC
SysForLoop65
	incf	AUXC,F
;for auxb = 1 to 15   'permanncia
	clrf	AUXB
SysForLoop66
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	15
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop66
SysForLoopEnd66
;next
	movlw	48
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop65
SysForLoopEnd65
;next
	movlw	10
	subwf	AUXD,W
	btfss	STATUS, C
	goto	SysForLoop62
SysForLoopEnd62
	return

;********************************************************************************

SOM_SIRENE21
;cnt = 64
	movlw	64
	movwf	CNT
;for auxd = 1 to 3   'numero de execues
	clrf	AUXD
SysForLoop67
	incf	AUXD,F
;for auxc = 1 to 10   'passo
	clrf	AUXC
SysForLoop68
	incf	AUXC,F
;cnt = 64
	movlw	64
	movwf	CNT
;for auxb = 1 to 50   'permanncia
	clrf	AUXB
SysForLoop69
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	50
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop69
SysForLoopEnd69
;cnt = 72
	movlw	72
	movwf	CNT
;for auxb = 1 to 50  'permanncia
	clrf	AUXB
SysForLoop70
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	50
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop70
SysForLoopEnd70
;next
	movlw	10
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop68
SysForLoopEnd68
;wait  2000 ms
	movlw	208
	movwf	SysWaitTempMS
	movlw	7
	movwf	SysWaitTempMS_H
	call	Delay_MS
;next
	movlw	3
	subwf	AUXD,W
	btfss	STATUS, C
	goto	SysForLoop67
SysForLoopEnd67
	return

;********************************************************************************

SOM_SIRENE22
;for auxe = 1 to 3  'numero de execues
	clrf	AUXE
SysForLoop71
	incf	AUXE,F
;cnt = 100 'frequencia
	movlw	100
	movwf	CNT
;for auxd = 1 to 4   'passo 2
	clrf	AUXD
SysForLoop72
	incf	AUXD,F
;for auxc = 1 to 10   'passo
	clrf	AUXC
SysForLoop73
	incf	AUXC,F
;for auxb = 1 to 40   'permanncia
	clrf	AUXB
SysForLoop74
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	40
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop74
SysForLoopEnd74
;cnt = cnt - 40
	movlw	40
	subwf	CNT,F
;next
	movlw	10
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop73
SysForLoopEnd73
;next
	movlw	4
	subwf	AUXD,W
	btfss	STATUS, C
	goto	SysForLoop72
SysForLoopEnd72
;cnt = 112
	movlw	112
	movwf	CNT
;next
	movlw	3
	subwf	AUXE,W
	btfss	STATUS, C
	goto	SysForLoop71
SysForLoopEnd71
	return

;********************************************************************************

SOM_SIRENE23
;for auxe = 1 to 5   'numero de execues
	clrf	AUXE
SysForLoop75
	incf	AUXE,F
;cnt = 70 'frequencia
	movlw	70
	movwf	CNT
;poim poim
;for auxd = 1 to 5   'numero de execues
	clrf	AUXD
SysForLoop76
	incf	AUXD,F
;for auxc = 1  to 15   'passo
	clrf	AUXC
SysForLoop77
	incf	AUXC,F
;for auxb = 1 to 40   'permanncia
	clrf	AUXB
SysForLoop78
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	40
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop78
SysForLoopEnd78
;cnt = cnt - 50
	movlw	50
	subwf	CNT,F
;next
	movlw	15
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop77
SysForLoopEnd77
;next
	movlw	5
	subwf	AUXD,W
	btfss	STATUS, C
	goto	SysForLoop76
SysForLoopEnd76
;cnt = 79
	movlw	79
	movwf	CNT
;next
	movlw	5
	subwf	AUXE,W
	btfss	STATUS, C
	goto	SysForLoop75
SysForLoopEnd75
	return

;********************************************************************************

SOM_SIRENE24
;for auxd = 1 to 3   'numero de execues
	clrf	AUXD
SysForLoop79
	incf	AUXD,F
;cnt = 10 'frequencia
	movlw	10
	movwf	CNT
;for auxc = 1 to 15   'passo
	clrf	AUXC
SysForLoop80
	incf	AUXC,F
;for auxb = 1 to 70   'permanncia
	clrf	AUXB
SysForLoop81
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	70
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop81
SysForLoopEnd81
;cnt = cnt - 12
	movlw	12
	subwf	CNT,F
;next
	movlw	15
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop80
SysForLoopEnd80
;next
	movlw	3
	subwf	AUXD,W
	btfss	STATUS, C
	goto	SysForLoop79
SysForLoopEnd79
	return

;********************************************************************************

SOM_SIRENE3
;sirene legal  alerta
;for auxd =1 to 50   'numero de execues
	clrf	AUXD
SysForLoop10
	incf	AUXD,F
;cnt = 100 'frequencia
	movlw	100
	movwf	CNT
;for auxc = 1 to 10   'passo
	clrf	AUXC
SysForLoop11
	incf	AUXC,F
;for auxb = 1  to 40   'permanncia
	clrf	AUXB
SysForLoop12
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	40
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop12
SysForLoopEnd12
;cnt = cnt - 2
	movlw	2
	subwf	CNT,F
;next
	movlw	10
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop11
SysForLoopEnd11
;next
	movlw	50
	subwf	AUXD,W
	btfss	STATUS, C
	goto	SysForLoop10
SysForLoopEnd10
	return

;********************************************************************************

SOM_SIRENE4
;sirene alarme rpido 1  toooouu! tooooouuu! toooouuu!
;for auxd = 1 to 30   'numero de execues
	clrf	AUXD
SysForLoop13
	incf	AUXD,F
;cnt = 20 'frequencia
	movlw	20
	movwf	CNT
;for auxc = 1 to 30   'passo
	clrf	AUXC
SysForLoop14
	incf	AUXC,F
;for auxb = 1  to 12   'permanncia
	clrf	AUXB
SysForLoop15
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	12
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop15
SysForLoopEnd15
;if cnt > 128 then
	movf	CNT,W
	sublw	128
	btfsc	STATUS, C
	goto	ELSE18_1
;cnt = cnt - 2
	movlw	2
	subwf	CNT,F
;else
	goto	ENDIF18
ELSE18_1
;cnt = cnt + 2
	movlw	2
	addwf	CNT,F
;end if
ENDIF18
;next
	movlw	30
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop14
SysForLoopEnd14
;next
	movlw	30
	subwf	AUXD,W
	btfss	STATUS, C
	goto	SysForLoop13
SysForLoopEnd13
	return

;********************************************************************************

SOM_SIRENE5
;sirene  disparos rpidos  usar junto com outra
;for auxd = 1 to 50  'numero de execues
	clrf	AUXD
SysForLoop16
	incf	AUXD,F
;cnt = 20' frequencia
	movlw	20
	movwf	CNT
;for  auxc = 1 to 10   'passo
	clrf	AUXC
SysForLoop17
	incf	AUXC,F
;for auxb = 1 to 12   'permanncia
	clrf	AUXB
SysForLoop18
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	12
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop18
SysForLoopEnd18
;if cnt > 128 then
	movf	CNT,W
	sublw	128
	btfsc	STATUS, C
	goto	ELSE22_1
;cnt = cnt - 5
	movlw	5
	subwf	CNT,F
;else
	goto	ENDIF22
ELSE22_1
;cnt = cnt + 5
	movlw	5
	addwf	CNT,F
;end if
ENDIF22
;next
	movlw	10
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop17
SysForLoopEnd17
;next
	movlw	50
	subwf	AUXD,W
	btfss	STATUS, C
	goto	SysForLoop16
SysForLoopEnd16
	return

;********************************************************************************

SOM_SIRENE6
;sirene  iaaauuuuu!  iiiaaauuu!
;for auxd = 1 to 10   'numero de execues
	clrf	AUXD
SysForLoop19
	incf	AUXD,F
;cnt = 20 'frequencia
	movlw	20
	movwf	CNT
;for auxc = 1 to 10  ' passo
	clrf	AUXC
SysForLoop20
	incf	AUXC,F
;for auxb = 1 to 80   'permanncia
	clrf	AUXB
SysForLoop21
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	80
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop21
SysForLoopEnd21
;if cnt > 128  then
	movf	CNT,W
	sublw	128
	btfsc	STATUS, C
	goto	ELSE26_1
;cnt = cnt - 5
	movlw	5
	subwf	CNT,F
;else
	goto	ENDIF26
ELSE26_1
;cnt = cnt + 5
	movlw	5
	addwf	CNT,F
;end if
ENDIF26
;next
	movlw	10
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop20
SysForLoopEnd20
;next
	movlw	10
	subwf	AUXD,W
	btfss	STATUS, C
	goto	SysForLoop19
SysForLoopEnd19
	return

;********************************************************************************

SOM_SIRENE7
;for auxd = 1 to 30   'numero de execues
	clrf	AUXD
SysForLoop22
	incf	AUXD,F
;cnt = 39 'frequencia
	movlw	39
	movwf	CNT
;for auxc = 1 to 12   'passo
	clrf	AUXC
SysForLoop23
	incf	AUXC,F
;for auxb = 1 to 6   'permanncia
	clrf	AUXB
SysForLoop24
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	6
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop24
SysForLoopEnd24
;cnt = cnt - 5
	movlw	5
	subwf	CNT,F
;next
	movlw	12
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop23
SysForLoopEnd23
;next
	movlw	30
	subwf	AUXD,W
	btfss	STATUS, C
	goto	SysForLoop22
SysForLoopEnd22
	return

;********************************************************************************

SOM_SIRENE8
;sirene alarme rpido 1
;for auxd = 1 to 10   'numero de execues
	clrf	AUXD
SysForLoop25
	incf	AUXD,F
;cnt = 40 'frequencia
	movlw	40
	movwf	CNT
;for auxc = 1 to 50   'passo
	clrf	AUXC
SysForLoop26
	incf	AUXC,F
;for auxb = 1 to 5   'permanncia
	clrf	AUXB
SysForLoop27
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	5
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop27
SysForLoopEnd27
;if cnt > 128 then
	movf	CNT,W
	sublw	128
	btfsc	STATUS, C
	goto	ELSE33_1
;cnt = cnt - 2
	movlw	2
	subwf	CNT,F
;else
	goto	ENDIF33
ELSE33_1
;cnt = cnt + 6
	movlw	6
	addwf	CNT,F
;end if
ENDIF33
;next
	movlw	50
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop26
SysForLoopEnd26
;next
	movlw	10
	subwf	AUXD,W
	btfss	STATUS, C
	goto	SysForLoop25
SysForLoopEnd25
	return

;********************************************************************************

SOM_SIRENE9
;som de arma espacial 1  tchooo'  lento
;for auxd = 1 to 10   'numero de execues
	clrf	AUXD
SysForLoop28
	incf	AUXD,F
;cnt = 40 'frequencia
	movlw	40
	movwf	CNT
;for auxc = 1 to 50  'passo
	clrf	AUXC
SysForLoop29
	incf	AUXC,F
;for auxb = 1 to 9   'permanncia
	clrf	AUXB
SysForLoop30
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	9
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop30
SysForLoopEnd30
;if cnt > 128 then
	movf	CNT,W
	sublw	128
	btfsc	STATUS, C
	goto	ELSE37_1
;cnt = cnt - 2
	movlw	2
	subwf	CNT,F
;else
	goto	ENDIF37
ELSE37_1
;cnt = cnt + 6
	movlw	6
	addwf	CNT,F
;end if
ENDIF37
;next
	movlw	50
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop29
SysForLoopEnd29
;next
	movlw	10
	subwf	AUXD,W
	btfss	STATUS, C
	goto	SysForLoop28
SysForLoopEnd28
	return

;********************************************************************************


 END
